/*
 * Хꥺɽե
 *	С
 *
 * Copyright (C) 1999,2000 Whitire Company (tonton@whitire.com)
 * $Id: br_about.c,v 1.2 2000/06/28 01:08:00 tonton Exp $
 */

#include <gtk/gtk.h>

#include "wmc_ptype.h"

#include "brthm.h"
#include "br_sdef.h"
#include "brthm.xpm"

static GtkWidget	*wbra_create_about_dialog(GtkWidget *);

/*===============
 *   ̾ : wbr_cb_mhelp_about_clicked()
 *     ǽ : Сκ
 *    : ʤ
 */
void				wbr_cb_mhelp_about_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			client_data,		// (I) ̤
guint				main_window			// (I) ᥤ󥦥ɥ
)
{
	GtkWidget		*about_dialog;		// С󥦥ɥ

	about_dialog =
		wbra_create_about_dialog(GUINT_TO_POINTER(main_window));
	gtk_widget_show_all(about_dialog);
}

/*===============
 *   ̾ : wbra_create_about_dialog()
 *     ǽ : С󥦥ɥ
 *    : С󥦥ɥ
 */
static GtkWidget	*wbra_create_about_dialog(
GtkWidget			*parent				// (I) ƥɥ
)
{
	GtkWidget		*about_dialog;		// С󥦥ɥ
	GtkWidget		*about_vbox;		//
	GtkWidget		*about_hbox;		//
	GdkPixmap		*pixmap;			// 
	GtkStyle		*style;				//
	GdkBitmap		*mask;				//
	GtkWidget		*about_pixmap;		//
	GtkWidget		*about_label;		// ٥
	GtkWidget		*about_action;		//
	GtkWidget		*about_ok;			// ϣ˥ܥ
	gchar			*title;				// ȥʸ

	// ɥ
	title = g_strconcat(WBR_TT_ABOUT, NULL);
	about_dialog = gtk_dialog_new();
	GTK_WINDOW(about_dialog)->type = GTK_WINDOW_DIALOG;
	gtk_window_set_title(GTK_WINDOW(about_dialog), title);
	gtk_window_set_position(GTK_WINDOW(about_dialog),
							GTK_WIN_POS_MOUSE);
	gtk_window_set_policy(GTK_WINDOW(about_dialog), TRUE, TRUE, FALSE);
	gtk_widget_realize(about_dialog);
	g_free(title);

	// 
	about_vbox = GTK_DIALOG(about_dialog)->vbox;
	gtk_container_set_border_width(GTK_CONTAINER(about_vbox), 10);

	about_hbox = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(about_vbox), about_hbox, FALSE, TRUE, 0);

	style = gtk_widget_get_default_style();
	pixmap = gdk_pixmap_create_from_xpm_d(about_dialog->window,
									&mask,
									&style->bg[GTK_STATE_NORMAL],
									brthm_xpm);
	about_pixmap = gtk_pixmap_new(pixmap, mask);
	gdk_pixmap_unref(pixmap);
	gdk_bitmap_unref(mask);
	gtk_widget_set_usize(about_pixmap, 32, 32);
	gtk_box_pack_start(GTK_BOX(about_hbox),
					about_pixmap, TRUE, TRUE, 0);

	// 
	title = g_strconcat("\n", WBR_TITLE, "\n",
				"Version ", WBR_VERSION, "\n\n",
				NULL);
	about_label = gtk_label_new(title);
	gtk_box_pack_start(GTK_BOX(about_hbox), about_label, TRUE, TRUE, 0);
	g_free(title);

	title = g_strconcat("Copyright Whitire Company\n",
						"1999,2000\n",
						"All rights reserved.\n",
				NULL);
	about_label = gtk_label_new(title);
	gtk_box_pack_start(GTK_BOX(about_vbox), about_label, TRUE, TRUE, 0);
	g_free(title);

	// ܥ
	about_action = GTK_DIALOG(about_dialog)->action_area;
	about_ok = gtk_button_new_with_label(WBR_STR_BTN_CONF);
	gtk_box_pack_start(GTK_BOX(about_action),
					about_ok, FALSE, FALSE, 0);
	gtk_signal_connect(GTK_OBJECT(about_ok), "clicked",
						GTK_SIGNAL_FUNC(wmc_dialog_close_clicked),
						GTK_OBJECT(about_dialog));
	GTK_WIDGET_SET_FLAGS(about_ok, GTK_CAN_DEFAULT);
	gtk_widget_grab_default(about_ok);

	gtk_window_set_modal(GTK_WINDOW(about_dialog), TRUE);
	gtk_window_set_transient_for(GTK_WINDOW(about_dialog),
								GTK_WINDOW(parent));

	return about_dialog;
}
