/*
 * Хꥺɽե
 *	ɽ
 *
 * Copyright (C) 1999,2000 Whitire Company (tonton@whitire.com)
 * $Id: br_idate.c,v 1.2 2000/06/28 01:08:00 tonton Exp $
 */

#include <gtk/gtk.h>
#include <time.h>

#include "wmc_ptype.h"

#include "brthm.h"
#include "br_sdef.h"

static GtkAdjustment	*Wbri_year;		// ǯ
static GtkAdjustment	*Wbri_month;	// 
static GtkAdjustment	*Wbri_day;		// 
static gint			Wbri_calendar;		// ܥֹ
static gfloat		Wbri_cal_year[] = {	// Ѵ
						0, 1867, 1911, 1925, 1988
					};

static GtkWidget	*wbri_create_date_window(GtkWidget *);
static void			wbri_cb_calendar_clicked(GtkWidget *,
											gpointer, guint);
static void			wbri_cb_ok_clicked(GtkWidget *, gpointer, guint);

/*===============
 *   ̾ : wbr_cb_mview_date_specify_clicked()
 *     ǽ : ջꥦɥκ
 *    : ʤ
 */
void				wbr_cb_mview_date_specify_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			client_data,		// (I) ̤
guint				main_window			// (I) ᥤ󥦥ɥ
)
{
	GtkWidget		*date_window;		// ջꥦɥ

	Wbri_calendar = (gint)wbr_get_param(WBR_PRM_ID_CALENDAR);
	date_window =
		wbri_create_date_window(GUINT_TO_POINTER(main_window));
	gtk_widget_show_all(date_window);
}

/*===============
 *   ̾ : wbri_cb_calendar_clicked()
 *     ǽ : ܥ󲡲Хå
 *    : ʤ
 */
static void			wbri_cb_calendar_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			btn_no,				// (I) ܥֹ
guint				call_data			// (I) ̤
)
{
	gboolean		is_active;			// ܥ󲡲
	gfloat			now_year;			// ǯ

	is_active = GTK_TOGGLE_BUTTON(button)->active;

	if (is_active == TRUE) {
		now_year = GTK_ADJUSTMENT(Wbri_year)->value
							+ Wbri_cal_year[Wbri_calendar];
		now_year -= Wbri_cal_year[(gint)btn_no];
		Wbri_calendar = (gint)btn_no;
		gtk_adjustment_set_value(GTK_ADJUSTMENT(Wbri_year), now_year);
	}
}

/*===============
 *   ̾ : wbri_cb_ok_clicked()
 *     ǽ : ɽܥ󲡲Хå
 *    : ʤ
 */
static void			wbri_cb_ok_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			main_window,		// (I) ջꥦɥ
guint				call_data			// (I) ̤
)
{
	time_t			ymd_time;			// ɽ
	struct tm		ymd_stime;			// ɽ

	memset(&ymd_stime, 0, sizeof(struct tm));
	ymd_stime.tm_year = GTK_ADJUSTMENT(Wbri_year)->value
						+ Wbri_cal_year[Wbri_calendar] - 1900;
	ymd_stime.tm_mon = GTK_ADJUSTMENT(Wbri_month)->value - 1;
	ymd_stime.tm_mday = GTK_ADJUSTMENT(Wbri_day)->value;

	ymd_time = mktime(&ymd_stime);
	wbr_put_param(WBR_PRM_ID_DISPDAY, (void *)ymd_time);
	wbr_put_param(WBR_PRM_ID_CALENDAR, (void *)Wbri_calendar);

	gtk_widget_destroy(main_window);
	wbr_draw_brthm();
}

/*===============
 *   ̾ : wbri_create_date_window()
 *     ǽ : ɥ
 *    : ɥ
 */
static GtkWidget	*wbri_create_date_window(
GtkWidget			*parent				// (I) ƥɥ
)
{
	gchar			*cal_str[] = {		// ʸ
						WBR_STR_CALENDAR1,
						WBR_STR_CALENDAR2,
						WBR_STR_CALENDAR3,
						WBR_STR_CALENDAR4,
						WBR_STR_CALENDAR5
					};
	GtkWidget		*date_window;		// ջꥦɥ
	GtkWidget		*date_vbox;			//
	GtkWidget		*title_label;		// ٥
	GtkWidget		*cal_hbox;			// Ǽܥå
	GtkWidget		*cal_btn = NULL;	// ܥ
	GSList			*cal_group = NULL;	// 񥰥롼ײ
	gint			loop_cnt;			// 롼ץ
	GtkWidget		*ymd_hbox;			// ǯǼܥå
	GtkWidget		*ymd_label;			// ǯ٥
	GtkWidget		*ymd_spin;			//
	time_t			ymd_time;			// ɽ
	struct tm		*ymd_stime;			// ɽ
	gfloat			ymd_value;			// ǯ
	GtkWidget		*date_sep;			// ѥ졼
	GtkWidget		*cmd_hbox;			// ܥܥå
	GtkWidget		*cmd_ok;			// ɽܥ
	GtkWidget		*cmd_cancel;		// ߥܥ
	gchar			*title;				// ȥʸ

	// ɥ
	title = g_strconcat(WBR_TT_IDATE, NULL);
	date_window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW(date_window), title);
	gtk_window_set_position(GTK_WINDOW(date_window), GTK_WIN_POS_MOUSE);
	gtk_window_set_policy(GTK_WINDOW(date_window), TRUE, TRUE, FALSE);
	g_free(title);

	// ٥
	date_vbox = gtk_vbox_new(FALSE, 0);
	gtk_container_set_border_width(GTK_CONTAINER(date_vbox), 2);
	gtk_container_add(GTK_CONTAINER(date_window), date_vbox);

	title = g_strconcat(WBR_STR_IDATE_MSG, NULL);
	title_label = gtk_label_new(title);
	gtk_misc_set_alignment(GTK_MISC(title_label), 0, 0);
	gtk_box_pack_start(GTK_BOX(date_vbox), title_label, TRUE, TRUE, 0);
	g_free(title);

	// 
	cal_hbox = gtk_hbox_new(FALSE, 10);
	gtk_container_border_width(GTK_CONTAINER(date_window), 10);
	gtk_box_pack_start(GTK_BOX(date_vbox), cal_hbox, FALSE, TRUE, 0);

	for (loop_cnt = 0;
		loop_cnt < (sizeof(cal_str) / sizeof(cal_str[0])); loop_cnt++) {
		if (loop_cnt) {
			cal_group =
				gtk_radio_button_group(GTK_RADIO_BUTTON(cal_btn));
			cal_btn = gtk_radio_button_new_with_label(cal_group,
											cal_str[loop_cnt]);
		}
		else {
			cal_btn = gtk_radio_button_new_with_label(NULL,
											cal_str[loop_cnt]);
		}
		if (Wbri_calendar == loop_cnt) {
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(cal_btn),
										TRUE);
		}
		gtk_box_pack_start(GTK_BOX(cal_hbox), cal_btn, TRUE, TRUE, 0);
		gtk_signal_connect(GTK_OBJECT(cal_btn), "clicked",
							GTK_SIGNAL_FUNC(wbri_cb_calendar_clicked),
							(gpointer)loop_cnt);
	}

	// ǯϥꥢ
	ymd_hbox = gtk_hbox_new (FALSE, 0);
	gtk_box_pack_start(GTK_BOX(date_vbox), ymd_hbox, TRUE, TRUE, 5);

	ymd_time = (time_t)wbr_get_param(WBR_PRM_ID_DISPDAY);
	ymd_stime = localtime(&ymd_time);
	ymd_value = (gfloat)ymd_stime->tm_year + 1900
					- Wbri_cal_year[Wbri_calendar];
	Wbri_year = (GtkAdjustment *)gtk_adjustment_new(ymd_value, 0.0,
										2100.0, 1.0, 100.0, 0.0);
	ymd_spin = gtk_spin_button_new(Wbri_year, 0, 0);
	gtk_spin_button_set_wrap(GTK_SPIN_BUTTON(ymd_spin), TRUE);
	gtk_spin_button_set_shadow_type(GTK_SPIN_BUTTON(ymd_spin),
									GTK_SHADOW_ETCHED_IN);
	gtk_widget_set_usize(ymd_spin, 55, 0);
	gtk_box_pack_start(GTK_BOX(ymd_hbox), ymd_spin, FALSE, TRUE, 5);
	ymd_label = gtk_label_new(WBR_STR_YEAR);
	gtk_misc_set_alignment(GTK_MISC(ymd_label), 0, 0.5);
	gtk_box_pack_start(GTK_BOX(ymd_hbox), ymd_label, FALSE, TRUE, 2);

	ymd_value = (gfloat)ymd_stime->tm_mon + 1;
	Wbri_month = (GtkAdjustment *)gtk_adjustment_new(ymd_value, 1.0,
										12.0, 1.0, 5.0, 0.0);
	ymd_spin = gtk_spin_button_new(Wbri_month, 0, 0);
	gtk_spin_button_set_wrap(GTK_SPIN_BUTTON(ymd_spin), TRUE);
	gtk_spin_button_set_shadow_type(GTK_SPIN_BUTTON(ymd_spin),
									GTK_SHADOW_ETCHED_IN);
	gtk_widget_set_usize(ymd_spin, 55, 0);
	gtk_box_pack_start(GTK_BOX(ymd_hbox), ymd_spin, FALSE, TRUE, 5);
	ymd_label = gtk_label_new(WBR_STR_MONTH);
	gtk_misc_set_alignment(GTK_MISC(ymd_label), 0, 0.5);
	gtk_box_pack_start(GTK_BOX(ymd_hbox), ymd_label, FALSE, TRUE, 2);

	ymd_value = (gfloat)ymd_stime->tm_mday;
	Wbri_day = (GtkAdjustment *)gtk_adjustment_new(ymd_value, 1.0,
										31.0, 1.0, 5.0, 0.0);
	ymd_spin = gtk_spin_button_new(Wbri_day, 0, 0);
	gtk_spin_button_set_wrap(GTK_SPIN_BUTTON(ymd_spin), TRUE);
	gtk_spin_button_set_shadow_type(GTK_SPIN_BUTTON(ymd_spin),
									GTK_SHADOW_ETCHED_IN);
	gtk_widget_set_usize(ymd_spin, 55, 0);
	gtk_box_pack_start(GTK_BOX(ymd_hbox), ymd_spin, FALSE, TRUE, 5);
	ymd_label = gtk_label_new(WBR_STR_DAY);
	gtk_misc_set_alignment(GTK_MISC(ymd_label), 0, 0.5);
	gtk_box_pack_start(GTK_BOX(ymd_hbox), ymd_label, FALSE, TRUE, 2);

	// ѥ졼
	date_sep = gtk_hseparator_new();
	gtk_box_pack_start(GTK_BOX(date_vbox), date_sep, FALSE, TRUE, 5);

	// ܥ
	cmd_hbox = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_end(GTK_BOX(date_vbox), cmd_hbox, FALSE, TRUE, 0);

	cmd_cancel = gtk_button_new_with_label(WBR_STR_BTN_CANCEL);
	gtk_box_pack_end(GTK_BOX(cmd_hbox), cmd_cancel, FALSE, TRUE, 5);
	gtk_signal_connect(GTK_OBJECT(cmd_cancel), "clicked",
						GTK_SIGNAL_FUNC(wmc_dialog_close_clicked),
						GTK_OBJECT(date_window));
	GTK_WIDGET_SET_FLAGS(cmd_cancel, GTK_CAN_DEFAULT);
	gtk_widget_grab_default(cmd_cancel);

	cmd_ok = gtk_button_new_with_label(WBR_STR_BTN_DISP);
	gtk_box_pack_end(GTK_BOX(cmd_hbox), cmd_ok, FALSE, TRUE, 5);
	gtk_signal_connect(GTK_OBJECT(cmd_ok), "clicked",
						GTK_SIGNAL_FUNC(wbri_cb_ok_clicked),
						GTK_OBJECT(date_window));
	GTK_WIDGET_SET_FLAGS(cmd_ok, GTK_CAN_DEFAULT);
	gtk_widget_grab_default(cmd_ok);

	gtk_window_set_modal(GTK_WINDOW(date_window), TRUE);
	gtk_window_set_transient_for(GTK_WINDOW(date_window),
								GTK_WINDOW(parent));

	return date_window;
}
