/*
 * ̴ؿ
 *	顼
 *
 * Copyright (C) 1999,2000 Whitire Company (tonton@whitire.com)
 * $Id: wmc_edlg.c,v 1.1 2000/06/27 15:01:03 tonton Exp $
 */

#include <gtk/gtk.h>

#include "wmc_sdef.h"
#include "wmc_ptype.h"
#include "exclm.xpm"

/*===============
 *   ̾ : wmc_create_emsg_dialog()
 *     ǽ : 顼å
 *    : ʤ
 */
void				wmc_create_emsg_dialog(
GtkWidget			*parent,			// (I) ƥɥ
gchar				*title_msg,			// (I) ȥ
gchar				*err_msg			// (I) 顼å
)
{
	GtkWidget		*emsg_dialog;		// 顼å
	GtkWidget		*emsg_vbox;			//
	GtkWidget		*emsg_hbox;			//
	GdkPixmap		*pixmap;			// 
	GtkStyle		*style;				//
	GdkBitmap		*mask;				//
	GtkWidget		*emsg_pixmap;		//
	GtkWidget		*emsg_label;		// ٥
	GtkWidget		*emsg_action;		//
	GtkWidget		*emsg_ok;			// ϣ˥ܥ

	// 
	emsg_dialog = gtk_dialog_new();
	GTK_WINDOW(emsg_dialog)->type = GTK_WINDOW_DIALOG;
	gtk_window_set_title(GTK_WINDOW(emsg_dialog), title_msg);
	gtk_window_set_position(GTK_WINDOW(emsg_dialog),
							GTK_WIN_POS_MOUSE);
	gtk_window_set_policy(GTK_WINDOW(emsg_dialog), TRUE, TRUE, FALSE);
	gtk_widget_realize(emsg_dialog);

	// 
	emsg_vbox = GTK_DIALOG(emsg_dialog)->vbox;
	gtk_container_set_border_width(GTK_CONTAINER(emsg_vbox), 5);

	emsg_hbox = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(emsg_vbox), emsg_hbox, FALSE, TRUE, 10);

	style = gtk_widget_get_default_style();
	pixmap = gdk_pixmap_create_from_xpm_d(emsg_dialog->window,
									&mask,
									&style->bg[GTK_STATE_NORMAL],
									exclm_xpm);
	emsg_pixmap = gtk_pixmap_new(pixmap, mask);
	gdk_pixmap_unref(pixmap);
	gdk_bitmap_unref(mask);
	gtk_widget_set_usize(emsg_pixmap, 32, 32);
	gtk_box_pack_start(GTK_BOX(emsg_hbox),
					emsg_pixmap, TRUE, TRUE, 0);

	// 
	emsg_label = gtk_label_new(err_msg);
	gtk_box_pack_start(GTK_BOX(emsg_hbox), emsg_label, TRUE, TRUE, 0);

	// ܥ
	emsg_action = GTK_DIALOG(emsg_dialog)->action_area;
	emsg_ok = gtk_button_new_with_label(WMC_STR_BTN_CONF);
	gtk_box_pack_start(GTK_BOX(emsg_action),
					emsg_ok, FALSE, FALSE, 0);
	gtk_signal_connect(GTK_OBJECT(emsg_ok), "clicked",
						GTK_SIGNAL_FUNC(wmc_dialog_close_clicked),
						GTK_OBJECT(emsg_dialog));
	GTK_WIDGET_SET_FLAGS(emsg_ok, GTK_CAN_DEFAULT);
	gtk_widget_grab_default(emsg_ok);

	gtk_window_set_modal(GTK_WINDOW(emsg_dialog), TRUE);
	gtk_window_set_transient_for(GTK_WINDOW(emsg_dialog),
								GTK_WINDOW(parent));

	gtk_widget_show_all(emsg_dialog);
}
