/*
 * Хꥺɽե
 *	ɽ
 *
 * Copyright (C) 1999,2000 Whitire Company (tonton@whitire.com)
 * $Id: br_birth.c,v 1.2 2000/06/28 01:08:00 tonton Exp $
 */

#include <gtk/gtk.h>
#include <stdio.h>
#include <string.h>
#include <time.h>

#include "wmc_ptype.h"

#include "brthm.h"
#include "br_sdef.h"

static GtkWidget	*Wbrb_name;			// ̾
static GtkAdjustment	*Wbrb_year;		// ǯ
static GtkAdjustment	*Wbrb_month;	// 
static GtkAdjustment	*Wbrb_day;		// 
static GtkWidget	*Wbrb_list;			// ꥹ
static gboolean		Wbrb_rmflag;		// ե饰
static gint			Wbrb_calendar;		// ܥֹ
static gfloat		Wbrb_cal_year[] = {	// Ѵ
						0, 1867, 1911, 1925, 1988
					};
static WBR_MAN_INFO	Wbrb_man_info;		// ;
static gboolean		Wbrb_chg_flag;		// ѹե饰

static void			wbrb_cb_destroy(void);
static void			wbrb_cb_list_selected(GtkWidget *,
						gint, gint, GdkEventButton *, gpointer);
static void			wbrb_cb_list_unselected(GtkWidget *,
						gint, gint, GdkEventButton *, gpointer);
static void			wbrb_cb_add_clicked(GtkWidget *, gpointer, guint);
static void			wbrb_cb_delete_clicked(GtkWidget *,
										gpointer, guint);
static void			wbrb_cb_calendar_clicked(GtkWidget *,
										gpointer, guint);
static void			wbrb_cb_allsel_clicked(GtkWidget *,
										gpointer, guint);
static void			wbrb_cb_allcan_clicked(GtkWidget *,
										gpointer, guint);
static gint			wbrb_cb_delete_event(GtkWidget *,
										GdkEvent *, gpointer);
static void			wbrb_cb_ok_clicked(GtkWidget *, gpointer, guint);
static void			wbrb_cb_cancel_clicked(GtkWidget *,
										gpointer, guint);
static GtkWidget	*wbrb_create_birth_window(GtkWidget *);
static void			wbrb_set_birthday_data(gchar *, time_t);

/*===============
 *   ̾ : wbr_cb_mview_spcbirth_clicked()
 *     ǽ : ϥɥκ
 *    : ʤ
 */
void				wbr_cb_mview_spcbirth_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			client_data,		// (I) ̤
guint				main_window			// (I) ᥤ󥦥ɥ
)
{
	GtkWidget		*birth_window;		// ϥɥ

	Wbrb_rmflag = FALSE;
	Wbrb_chg_flag = FALSE;
	Wbrb_calendar = (gint)wbr_get_param(WBR_PRM_ID_CALENDAR);
	birth_window =
		wbrb_create_birth_window(GUINT_TO_POINTER(main_window));
	gtk_widget_show_all(birth_window);
	gtk_main();
}

/*===============
 *   ̾ : wbrb_cb_destroy()
 *     ǽ : ɥ˲Хå
 *    : ʤ
 */
static void			wbrb_cb_destroy(void)
{
	g_free(Wbrb_man_info.man_dat);
	gtk_main_quit();
}

/*===============
 *   ̾ : wbrb_cb_list_selected()
 *     ǽ : ꥹ򥳡Хå
 *    : ʤ
 */
static void			wbrb_cb_list_selected(
GtkWidget			*list,				// (I) ꥹ
gint				row,				// (I) 
gint				column,				// (I) 
GdkEventButton		*event,				// (I) ꥹ
gpointer			call_data			// (I) ̤
)
{
	if (Wbrb_rmflag == FALSE) {
		wbr_set_selected(&Wbrb_man_info, row, TRUE);
	}
}

/*===============
 *   ̾ : wbrb_cb_list_unselected()
 *     ǽ : ꥹ򥳡Хå
 *    : ʤ
 */
static void			wbrb_cb_list_unselected(
GtkWidget			*list,				// (I) ꥹ
gint				row,				// (I) 
gint				column,				// (I) 
GdkEventButton		*event,				// (I) ꥹ
gpointer			call_data			// (I) ̤
)
{
	if (Wbrb_rmflag == FALSE) {
		wbr_set_selected(&Wbrb_man_info, row, FALSE);
	}
}

/*===============
 *   ̾ : wbrb_cb_calendar_clicked()
 *     ǽ : ܥ󲡲Хå
 *    : ʤ
 */
static void			wbrb_cb_calendar_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			btn_no,				// (I) ܥֹ
guint				call_data			// (I) ̤
)
{
	gboolean		is_active;			// ܥ󲡲
	gfloat			now_year;			// ǯ

	is_active = GTK_TOGGLE_BUTTON(button)->active;

	if (is_active == TRUE) {
		now_year = GTK_ADJUSTMENT(Wbrb_year)->value
							+ Wbrb_cal_year[Wbrb_calendar];
		now_year -= Wbrb_cal_year[(gint)btn_no];
		Wbrb_calendar = (gint)btn_no;
		gtk_adjustment_set_value(GTK_ADJUSTMENT(Wbrb_year), now_year);
	}
}

/*===============
 *   ̾ : wbrb_cb_add_clicked()
 *     ǽ : ɲåܥ󲡲Хå
 *    : ʤ
 */
static void			wbrb_cb_add_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			main_window,		// (I) ϥɥ
guint				call_data			// (I) ̤
)
{
	gchar			*user_name;			// ̾
	time_t			ymd_time;			// ɽ
	struct tm		ymd_stime;			// ɽ
	gchar			ymd_string[20];		// ɽ
	gchar			**list_item;		// ꥹȹ
	WBR_MAN_DAT		*man_dat;			// ;

	user_name = gtk_entry_get_text(GTK_ENTRY(Wbrb_name));
	if (user_name[0] != '\0') {
		memset(&ymd_stime, 0, sizeof(struct tm));
		ymd_stime.tm_year = GTK_ADJUSTMENT(Wbrb_year)->value
							+ Wbrb_cal_year[Wbrb_calendar] - 1900;
		ymd_stime.tm_mon = GTK_ADJUSTMENT(Wbrb_month)->value - 1;
		ymd_stime.tm_mday = GTK_ADJUSTMENT(Wbrb_day)->value;
		ymd_time = mktime(&ymd_stime);

		if ((gboolean)wbr_get_param(WBR_PRM_ID_BIRTHYEAR) == TRUE) {
			sprintf(ymd_string, "%d/%02d/%02d",
				ymd_stime.tm_year + 1900,
				ymd_stime.tm_mon + 1, ymd_stime.tm_mday);
		}
		else {
			sprintf(ymd_string, "%02d/%02d",
				ymd_stime.tm_mon + 1, ymd_stime.tm_mday);
		}

		wbr_set_datfile(&Wbrb_man_info, user_name, ymd_time, TRUE);
		man_dat = &Wbrb_man_info.man_dat[Wbrb_man_info.man_cnt - 1];
		list_item = g_malloc(2 * sizeof(char *));
		list_item[0] = g_strconcat(man_dat->name, NULL);
		list_item[1] = g_strconcat(ymd_string, NULL);
		gtk_clist_append(GTK_CLIST(Wbrb_list), list_item);
		gtk_clist_select_row(GTK_CLIST(Wbrb_list),
							Wbrb_man_info.man_cnt - 1, 1);
		g_free(list_item[0]);
		g_free(list_item[1]);
		g_free(list_item);

		Wbrb_chg_flag = TRUE;
	}
	else {
		wmc_create_emsg_dialog(main_window,
			WBR_STR_ERROR, WBR_STR_ERR_LISTADD);
	}
}

/*===============
 *   ̾ : wbrb_cb_delete_clicked()
 *     ǽ : ܥ󲡲Хå
 *    : ʤ
 */
static void			wbrb_cb_delete_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			main_window,		// (I) ϥɥ
guint				call_data			// (I) ̤
)
{
	gint			loop_cnt;			// 롼ץ
	gint			sel_cnt;			// 
	gint			dat_cnt;			// ǡ
	gboolean		yes_no;				// γǧ
	WBR_MAN_DAT		*man_dat;			// ;

	sel_cnt = 0;
	man_dat = Wbrb_man_info.man_dat;
	for (loop_cnt = 0; loop_cnt < Wbrb_man_info.man_cnt; loop_cnt++) {
		if (man_dat->selected == TRUE) {
			sel_cnt++;
			if (sel_cnt > 1) {
break;
			}
		}
		man_dat++;
	}

	if (sel_cnt > 0) {
		yes_no = TRUE;
		if (sel_cnt > 1) {
			yes_no = wmc_create_qmsg_dialog(main_window,
						WBR_STR_QUESTION, WBR_STR_QST_SMSEL);
		}

		if (yes_no == TRUE) {
			Wbrb_rmflag = TRUE;
			dat_cnt = Wbrb_man_info.man_cnt - 1;
			man_dat = &Wbrb_man_info.man_dat[dat_cnt];
			for (loop_cnt = dat_cnt; loop_cnt >= 0; loop_cnt--) {
				if (man_dat->selected == TRUE) {
					wbrb_set_birthday_data(man_dat->name,
										man_dat->birthday);
					wbr_delete_datfile(&Wbrb_man_info, loop_cnt);
					gtk_clist_remove(GTK_CLIST(Wbrb_list), loop_cnt);

					Wbrb_chg_flag = TRUE;
				}
				man_dat--;
			}
			Wbrb_rmflag = FALSE;
		}
	}
	else {
		wmc_create_emsg_dialog(main_window,
			WBR_STR_ERROR, WBR_STR_ERR_LISTSEL);
	}
}

/*===============
 *   ̾ : wbrb_cb_allsel_clicked()
 *     ǽ : ܥ󲡲Хå
 *    : ʤ
 */
static void			wbrb_cb_allsel_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			client_data,		// (I) ̤
guint				call_data			// (I) ̤
)
{
	gtk_clist_select_all(GTK_CLIST(Wbrb_list));
}

/*===============
 *   ̾ : wbrb_cb_allcan_clicked()
 *     ǽ : ܥ󲡲Хå
 *    : ʤ
 */
static void			wbrb_cb_allcan_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			client_data,		// (I) ̤
guint				call_data			// (I) ̤
)
{
	gtk_clist_unselect_all(GTK_CLIST(Wbrb_list));
}

/*===============
 *   ̾ : wbrb_cb_delete_event()
 *     ǽ : ߥܥ󲡲Хå
 *    : FALSE= ˲
 */
static gint			wbrb_cb_delete_event(
GtkWidget			*button,			// (I) ܥ
GdkEvent			*event,				// (I) ٥
gpointer			main_window			// (I) ϥɥ
)
{
	if (Wbrb_chg_flag == TRUE) {
		wbrb_cb_cancel_clicked(button, main_window, 0);
	}

	return FALSE;
}

/*===============
 *   ̾ : wbrb_cb_ok_clicked()
 *     ǽ : ɽܥ󲡲Хå
 *    : ʤ
 */
static void			wbrb_cb_ok_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			main_window,		// (I) ϥɥ
guint				call_data			// (I) ̤
)
{
	gint			loop_cnt;			// 롼ץ
	gboolean		sel_flag = FALSE;	// ե饰
	WBR_MAN_DAT		*man_dat;			// ;

	man_dat = Wbrb_man_info.man_dat;
	for (loop_cnt = 0; loop_cnt < Wbrb_man_info.man_cnt; loop_cnt++) {
		if (man_dat->selected == TRUE) {
			sel_flag = TRUE;
break;
		}
		man_dat++;
	}

	if (sel_flag == TRUE) {
		wbr_init_user_info();
		man_dat = Wbrb_man_info.man_dat;
		for (loop_cnt = 0;
			loop_cnt < Wbrb_man_info.man_cnt; loop_cnt++) {
			if (man_dat->selected == TRUE) {
				wbr_put_user_info(man_dat->name, man_dat->birthday);
			}
			man_dat++;
		}
		wbr_put_param(WBR_PRM_ID_CALENDAR, (void *)Wbrb_calendar);
		wbr_write_datfile(&Wbrb_man_info);

		gtk_widget_destroy(main_window);
		wbr_set_birthday_info();
		wbr_draw_brthm();
	}
	else {
		wmc_create_emsg_dialog(main_window,
			WBR_STR_ERROR, WBR_STR_ERR_LISTSEL);
	}
}

/*===============
 *   ̾ : wbrb_cb_cancel_clicked()
 *     ǽ : ߥܥ󲡲Хå
 *    : ʤ
 */
static void			wbrb_cb_cancel_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			main_window,		// (I) ϥɥ
guint				call_data			// (I) ̤
)
{
	gboolean		yes_no;				// ¸γǧ

	if (Wbrb_chg_flag == TRUE) {
		yes_no = wmc_create_qmsg_dialog(main_window,
					WBR_STR_QUESTION, WBR_STR_QST_SAVE);
		if (yes_no == TRUE) {
			wbr_write_datfile(&Wbrb_man_info);
		}
	}

	gtk_widget_destroy(main_window);
}

/*===============
 *   ̾ : wbrb_create_birth_window()
 *     ǽ : ɥ
 *    : ɥ
 */
static GtkWidget	*wbrb_create_birth_window(
GtkWidget			*parent				// (I) ƥɥ
)
{
	gchar			*cal_str[] = {		// ʸ
						WBR_STR_CALENDAR1,
						WBR_STR_CALENDAR2,
						WBR_STR_CALENDAR3,
						WBR_STR_CALENDAR4,
						WBR_STR_CALENDAR5
					};
	gchar			*list_titles[] = {	// ꥹȹ̾
						WBR_STR_LIST_NAME, WBR_STR_LIST_BIRTH
					};
	GtkWidget		*birth_window;		// ϥɥ
	GtkWidget		*birth_vbox;		//
	GtkWidget		*title_label;		// ٥
	GtkWidget		*nb_hbox;			//
	GtkWidget		*name_vbox;			//
	GtkWidget		*cy_vbox;			//
	GtkWidget		*cal_hbox;			// Ǽܥå
	GtkWidget		*cal_btn = NULL;	// ܥ
	GSList			*cal_group = NULL;	// 񥰥롼ײ
	gint			loop_cnt;			// 롼ץ
	GtkWidget		*ymd_hbox;			// ǯǼܥå
	GtkWidget		*ymd_label;			// ǯ٥
	GtkWidget		*ymd_spin;			//
	GtkWidget		*list_hbox;			//
	GtkWidget		*list_scrl;			// 륦ɥ
	gchar			**list_item;		// ꥹȹ
	gchar			temp_date[20];		// ʸ
	gchar			date_fmt[20];		// եեޥå
	WBR_MAN_DAT		*man_dat;			// ;
	GtkWidget		*cmd_vbox;			//
	GtkWidget		*cmd_add;			// ɲåܥ
	GtkWidget		*cmd_delete;		// ܥ
	GtkWidget		*cmd_allsel;		// ܥ
	GtkWidget		*cmd_allcan;		// ܥ
	GtkWidget		*birth_sep;			// ѥ졼
	GtkWidget		*cmd_hbox;			// ܥܥå
	GtkWidget		*cmd_ok;			// ɽܥ
	GtkWidget		*cmd_cancel;		// ߥܥ
	gchar			*title;				// ȥʸ

	// ɥ
	title = g_strconcat(WBR_TT_BIRTH, NULL);
	birth_window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW(birth_window), title);
	gtk_window_set_position(GTK_WINDOW(birth_window),
							GTK_WIN_POS_MOUSE);
	gtk_window_set_policy(GTK_WINDOW(birth_window), TRUE, TRUE, FALSE);
	gtk_signal_connect(GTK_OBJECT(birth_window), "delete_event",
					GTK_SIGNAL_FUNC(wbrb_cb_delete_event),
					GTK_OBJECT(birth_window));
	gtk_signal_connect(GTK_OBJECT(birth_window), "destroy",
					GTK_SIGNAL_FUNC(wbrb_cb_destroy), NULL);
	g_free(title);

	// ٥
	birth_vbox = gtk_vbox_new(FALSE, 0);
	gtk_container_set_border_width(GTK_CONTAINER(birth_vbox), 5);
	gtk_container_add(GTK_CONTAINER(birth_window), birth_vbox);

	// ̾
	nb_hbox = gtk_hbox_new(FALSE, 10);
	gtk_box_pack_start(GTK_BOX(birth_vbox), nb_hbox, FALSE, TRUE, 0);

	name_vbox = gtk_vbox_new(FALSE, 10);
	gtk_box_pack_start(GTK_BOX(nb_hbox), name_vbox, FALSE, TRUE, 0);

	title = g_strconcat(WBR_STR_NAME, NULL);
	title_label = gtk_label_new(title);
	gtk_misc_set_alignment(GTK_MISC(title_label), 0, 0);
	gtk_box_pack_start(GTK_BOX(name_vbox), title_label, FALSE, TRUE, 0);
	g_free(title);

	Wbrb_name = gtk_entry_new_with_max_length(20);
	gtk_box_pack_start(GTK_BOX(name_vbox), Wbrb_name, FALSE, TRUE, 0);

	// 
	cy_vbox = gtk_vbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(nb_hbox), cy_vbox, FALSE, TRUE, 0);

	cal_hbox = gtk_hbox_new(FALSE, 10);
	gtk_box_pack_start(GTK_BOX(cy_vbox), cal_hbox, FALSE, TRUE, 0);

	for (loop_cnt = 0;
		loop_cnt < (sizeof(cal_str) / sizeof(cal_str[0])); loop_cnt++) {
		if (loop_cnt) {
			cal_group =
				gtk_radio_button_group(GTK_RADIO_BUTTON(cal_btn));
			cal_btn = gtk_radio_button_new_with_label(cal_group,
											cal_str[loop_cnt]);
		}
		else {
			cal_btn = gtk_radio_button_new_with_label(NULL,
											cal_str[loop_cnt]);
		}
		if (Wbrb_calendar == loop_cnt) {
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(cal_btn),
										TRUE);
		}
		gtk_box_pack_start(GTK_BOX(cal_hbox), cal_btn, TRUE, TRUE, 0);
		gtk_signal_connect(GTK_OBJECT(cal_btn), "clicked",
							GTK_SIGNAL_FUNC(wbrb_cb_calendar_clicked),
							(gpointer)loop_cnt);
	}

	// ǯϥꥢ
	ymd_hbox = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(cy_vbox), ymd_hbox, TRUE, TRUE, 5);

	Wbrb_year = (GtkAdjustment *)gtk_adjustment_new(0.0, 0.0,
										2100.0, 1.0, 100.0, 0.0);
	ymd_spin = gtk_spin_button_new(Wbrb_year, 0, 0);
	gtk_spin_button_set_wrap(GTK_SPIN_BUTTON(ymd_spin), TRUE);
	gtk_spin_button_set_shadow_type(GTK_SPIN_BUTTON(ymd_spin),
									GTK_SHADOW_ETCHED_IN);
	gtk_widget_set_usize(ymd_spin, 55, 0);
	gtk_box_pack_start(GTK_BOX(ymd_hbox), ymd_spin, FALSE, TRUE, 5);
	ymd_label = gtk_label_new(WBR_STR_YEAR);
	gtk_misc_set_alignment(GTK_MISC(ymd_label), 0, 0.5);
	gtk_box_pack_start(GTK_BOX(ymd_hbox), ymd_label, FALSE, TRUE, 2);

	Wbrb_month = (GtkAdjustment *)gtk_adjustment_new(0.0, 1.0,
										12.0, 1.0, 5.0, 0.0);
	ymd_spin = gtk_spin_button_new(Wbrb_month, 0, 0);
	gtk_spin_button_set_wrap(GTK_SPIN_BUTTON(ymd_spin), TRUE);
	gtk_spin_button_set_shadow_type(GTK_SPIN_BUTTON(ymd_spin),
									GTK_SHADOW_ETCHED_IN);
	gtk_widget_set_usize(ymd_spin, 55, 0);
	gtk_box_pack_start(GTK_BOX(ymd_hbox), ymd_spin, FALSE, TRUE, 5);
	ymd_label = gtk_label_new(WBR_STR_MONTH);
	gtk_misc_set_alignment(GTK_MISC(ymd_label), 0, 0.5);
	gtk_box_pack_start(GTK_BOX(ymd_hbox), ymd_label, FALSE, TRUE, 2);

	Wbrb_day = (GtkAdjustment *)gtk_adjustment_new(0.0, 1.0,
										31.0, 1.0, 5.0, 0.0);
	ymd_spin = gtk_spin_button_new(Wbrb_day, 0, 0);
	gtk_spin_button_set_wrap(GTK_SPIN_BUTTON(ymd_spin), TRUE);
	gtk_spin_button_set_shadow_type(GTK_SPIN_BUTTON(ymd_spin),
									GTK_SHADOW_ETCHED_IN);
	gtk_widget_set_usize(ymd_spin, 55, 0);
	gtk_box_pack_start(GTK_BOX(ymd_hbox), ymd_spin, FALSE, TRUE, 5);
	ymd_label = gtk_label_new(WBR_STR_DAY);
	gtk_misc_set_alignment(GTK_MISC(ymd_label), 0, 0.5);
	gtk_box_pack_start(GTK_BOX(ymd_hbox), ymd_label, FALSE, TRUE, 2);

	wbrb_set_birthday_data("", time(NULL));

	// ꥹȥܥå
	list_hbox = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(birth_vbox), list_hbox, TRUE, TRUE, 5);

	list_scrl = gtk_scrolled_window_new(NULL, NULL);
	gtk_container_set_border_width(GTK_CONTAINER(list_scrl), 0);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(list_scrl),
									GTK_POLICY_AUTOMATIC,
									GTK_POLICY_AUTOMATIC);
	gtk_widget_set_usize(GTK_WIDGET(list_scrl), 300, 200);
	gtk_box_pack_start(GTK_BOX(list_hbox), list_scrl, FALSE, TRUE, 20);

	Wbrb_list = gtk_clist_new_with_titles(2, list_titles);
	gtk_clist_set_column_width(GTK_CLIST(Wbrb_list), 0, 150);
	gtk_clist_set_selection_mode(GTK_CLIST(Wbrb_list),
								GTK_SELECTION_EXTENDED);

	wbr_read_datfile(&Wbrb_man_info);

	list_item = g_malloc(2 * sizeof(char *));
	man_dat = Wbrb_man_info.man_dat;

	if ((gboolean)wbr_get_param(WBR_PRM_ID_BIRTHYEAR) == TRUE) {
		strcpy(date_fmt, "%Y/%m/%d");
	}
	else {
		strcpy(date_fmt, "%m/%d");
	}
	for (loop_cnt = 0; loop_cnt < Wbrb_man_info.man_cnt; loop_cnt++) {
		strftime(temp_date, sizeof(temp_date),
			date_fmt, localtime(&man_dat->birthday));
		list_item[0] = g_strconcat(man_dat->name, NULL);
		list_item[1] = g_strconcat(temp_date, NULL);
		gtk_clist_append(GTK_CLIST(Wbrb_list), list_item);
		g_free(list_item[0]);
		g_free(list_item[1]);

		if (man_dat->selected == TRUE) {
			gtk_clist_select_row(GTK_CLIST(Wbrb_list), loop_cnt, 1);
		}
		man_dat++;
	}
	g_free(list_item);

	gtk_container_add(GTK_CONTAINER(list_scrl), Wbrb_list);
	gtk_signal_connect(GTK_OBJECT(Wbrb_list), "select_row",
						GTK_SIGNAL_FUNC(wbrb_cb_list_selected), NULL);
	gtk_signal_connect(GTK_OBJECT(Wbrb_list), "unselect_row",
						GTK_SIGNAL_FUNC(wbrb_cb_list_unselected), NULL);

	// Խܥ
	cmd_vbox = gtk_vbutton_box_new();
	gtk_box_pack_start(GTK_BOX(list_hbox), cmd_vbox, FALSE, FALSE, 10);
	gtk_container_set_border_width(GTK_CONTAINER(cmd_vbox), 0);
	gtk_button_box_set_layout(GTK_BUTTON_BOX(cmd_vbox),
								GTK_BUTTONBOX_START);
	gtk_button_box_set_spacing(GTK_BUTTON_BOX(cmd_vbox), 1);

	cmd_add = gtk_button_new_with_label(WBR_STR_BTN_ADD);
	gtk_container_add(GTK_CONTAINER(cmd_vbox), cmd_add);
	gtk_signal_connect(GTK_OBJECT(cmd_add), "clicked",
						GTK_SIGNAL_FUNC(wbrb_cb_add_clicked),
						GTK_OBJECT(birth_window));

	cmd_delete = gtk_button_new_with_label(WBR_STR_BTN_DELETE);
	gtk_container_add(GTK_CONTAINER(cmd_vbox), cmd_delete);
	gtk_signal_connect(GTK_OBJECT(cmd_delete), "clicked",
						GTK_SIGNAL_FUNC(wbrb_cb_delete_clicked),
						GTK_OBJECT(birth_window));

	birth_sep = gtk_hseparator_new();
	gtk_container_add(GTK_CONTAINER(cmd_vbox), birth_sep);

	cmd_allsel = gtk_button_new_with_label(WBR_STR_BTN_ALLSEL);
	gtk_container_add(GTK_CONTAINER(cmd_vbox), cmd_allsel);
	gtk_signal_connect(GTK_OBJECT(cmd_allsel), "clicked",
						GTK_SIGNAL_FUNC(wbrb_cb_allsel_clicked),
						NULL);

	cmd_allcan = gtk_button_new_with_label(WBR_STR_BTN_ALLCAN);
	gtk_container_add(GTK_CONTAINER(cmd_vbox), cmd_allcan);
	gtk_signal_connect(GTK_OBJECT(cmd_allcan), "clicked",
						GTK_SIGNAL_FUNC(wbrb_cb_allcan_clicked),
						NULL);

	// ѥ졼
	birth_sep = gtk_hseparator_new();
	gtk_box_pack_start(GTK_BOX(birth_vbox), birth_sep, FALSE, TRUE, 5);

	// ܥ
	cmd_hbox = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_end(GTK_BOX(birth_vbox), cmd_hbox, FALSE, TRUE, 0);

	cmd_cancel = gtk_button_new_with_label(WBR_STR_BTN_CANCEL);
	gtk_box_pack_end(GTK_BOX(cmd_hbox), cmd_cancel, FALSE, TRUE, 5);
	gtk_signal_connect(GTK_OBJECT(cmd_cancel), "clicked",
						GTK_SIGNAL_FUNC(wbrb_cb_cancel_clicked),
						GTK_OBJECT(birth_window));
	GTK_WIDGET_SET_FLAGS(cmd_cancel, GTK_CAN_DEFAULT);
	gtk_widget_grab_default(cmd_cancel);

	cmd_ok = gtk_button_new_with_label(WBR_STR_BTN_DISP);
	gtk_box_pack_end(GTK_BOX(cmd_hbox), cmd_ok, FALSE, TRUE, 5);
	gtk_signal_connect(GTK_OBJECT(cmd_ok), "clicked",
						GTK_SIGNAL_FUNC(wbrb_cb_ok_clicked),
						GTK_OBJECT(birth_window));
	GTK_WIDGET_SET_FLAGS(cmd_ok, GTK_CAN_DEFAULT);
	gtk_widget_grab_default(cmd_ok);

	if (parent != NULL) {
		gtk_window_set_modal(GTK_WINDOW(birth_window), TRUE);
		gtk_window_set_transient_for(GTK_WINDOW(birth_window),
									GTK_WINDOW(parent));
	}

	return birth_window;
}

/*===============
 *   ̾ : wbrb_set_birthday_data()
 *     ǽ : ̾Υå
 *    : ʤ
 */
static void			wbrb_set_birthday_data(
gchar				*name,				// (I) ̾
time_t				birthday			// (I) 
)
{
	struct tm		*ymd_stime;			// ɽ
	gfloat			ymd_value;			// ǯ

	gtk_entry_set_text(GTK_ENTRY(Wbrb_name), name);

	ymd_stime = localtime(&birthday);
	ymd_value = (gfloat)ymd_stime->tm_year + 1900
					- Wbrb_cal_year[Wbrb_calendar];
	gtk_adjustment_set_value(Wbrb_year, ymd_value);
	ymd_value = (gfloat)ymd_stime->tm_mon + 1;
	gtk_adjustment_set_value(Wbrb_month, ymd_value);
	ymd_value = (gfloat)ymd_stime->tm_mday;
	gtk_adjustment_set_value(Wbrb_day, ymd_value);
}
