/*
 * Хꥺɽե
 *	ץ
 *
 * Copyright (C) 1999,2000 Whitire Company (tonton@whitire.com)
 * $Id: br_option.c,v 1.1 2000/06/28 01:08:00 tonton Exp $
 */

#include <gtk/gtk.h>

#include "wmc_ptype.h"

#include "brthm.h"
#include "br_sdef.h"

static GtkAdjustment	*Wbro_graph_disp;// ɽ
static GtkAdjustment	*Wbro_line_width;// դ
static GtkAdjustment	*Wbro_disp_day;	// ɽ
static GtkWidget	*Wbro_birth_year;	// ɽ
static GtkWidget	*Wbro_total;		// ɽ
static GtkWidget	*Wbro_day_line;		// ɽ

static GtkWidget	*wbro_create_option_window(GtkWidget *);
static void			wbro_cb_ok_clicked(GtkWidget *, gpointer, guint);

/*===============
 *   ̾ : wbr_cb_mview_option_clicked()
 *     ǽ : ץꥦɥκ
 *    : ʤ
 */
void				wbr_cb_mview_option_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			client_data,		// (I) ̤
guint				main_window			// (I) ᥤ󥦥ɥ
)
{
	GtkWidget		*opt_window;		// ץꥦɥ

	opt_window =
		wbro_create_option_window(GUINT_TO_POINTER(main_window));
	gtk_widget_show_all(opt_window);
}

/*===============
 *   ̾ : wbro_cb_ok_clicked()
 *     ǽ : ܥ󲡲Хå
 *    : ʤ
 */
static void			wbro_cb_ok_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			main_window,		// (I) ץꥦɥ
guint				call_data			// (I) ̤
)
{
	gint			opt_value;			// ץ

	opt_value = WBR_INTERVAL
				- GTK_ADJUSTMENT(Wbro_graph_disp)->value + 1;
	wbr_put_param(WBR_PRM_ID_GRAPHPOINT, (void *)opt_value);

	opt_value = GTK_ADJUSTMENT(Wbro_line_width)->value;
	wbr_put_param(WBR_PRM_ID_LINEWIDTH, (void *)opt_value);

	opt_value = GTK_ADJUSTMENT(Wbro_disp_day)->value;
	wbr_put_param(WBR_PRM_ID_DISPPERIOD, (void *)opt_value);

	opt_value = GTK_TOGGLE_BUTTON(Wbro_birth_year)->active;
	wbr_put_param(WBR_PRM_ID_BIRTHYEAR, (void *)opt_value);

	opt_value = GTK_TOGGLE_BUTTON(Wbro_total)->active;
	wbr_put_param(WBR_PRM_ID_DISPTOTAL, (void *)opt_value);

	opt_value = GTK_TOGGLE_BUTTON(Wbro_day_line)->active;
	wbr_put_param(WBR_PRM_ID_DAYLINE, (void *)opt_value);

	gtk_widget_destroy(main_window);
	wbr_draw_brthm();
	wbr_set_birthday_info();
}

/*===============
 *   ̾ : wbro_create_option_window()
 *     ǽ : ɥ
 *    : ɥ
 */
static GtkWidget	*wbro_create_option_window(
GtkWidget			*parent				// (I) ƥɥ
)
{
	GtkWidget		*opt_window;		// ɥ
	GtkWidget		*opt_vbox;			//
	GtkWidget		*opt_hbox;			//
	GtkWidget		*title_label;		// ٥
	gdouble			opt_value;			// ץ
	GtkWidget		*opt_scale;			//
	GtkWidget		*opt_spin;			//
	GtkWidget		*opt_sep;			// ѥ졼
	GtkWidget		*cmd_hbox;			// ܥܥå
	GtkWidget		*cmd_ok;			// ܥ
	GtkWidget		*cmd_cancel;		// ߥܥ
	gchar			*title;				// ȥʸ

	// ɥ
	title = g_strconcat(WBR_TT_OPTION, NULL);
	opt_window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW(opt_window), title);
	gtk_window_set_position(GTK_WINDOW(opt_window),
							GTK_WIN_POS_MOUSE);
	gtk_window_set_policy(GTK_WINDOW(opt_window), TRUE, TRUE, FALSE);
	g_free(title);

	// ɽ
	opt_vbox = gtk_vbox_new(FALSE, 0);
	gtk_container_set_border_width(GTK_CONTAINER(opt_vbox), 5);
	gtk_container_add(GTK_CONTAINER(opt_window), opt_vbox);

	opt_hbox = gtk_hbox_new(FALSE, 10);
	gtk_box_pack_start(GTK_BOX(opt_vbox), opt_hbox, FALSE, TRUE, 5);

	title_label = gtk_label_new(WBR_STR_GRAPH_DISP1);
	gtk_misc_set_alignment(GTK_MISC(title_label), 0, 0);
	gtk_box_pack_start(GTK_BOX(opt_hbox), title_label, FALSE, TRUE, 0);

	opt_value = (gdouble)((gint)wbr_get_param(WBR_PRM_ID_GRAPHPOINT));
	opt_value = WBR_INTERVAL - opt_value + 1;
	Wbro_graph_disp = (GtkAdjustment *)gtk_adjustment_new(opt_value,
										1.0, 5.0, 1.0, 1.0, 0.0);
	opt_scale = gtk_hscale_new(GTK_ADJUSTMENT(Wbro_graph_disp));
	gtk_widget_set_usize(GTK_WIDGET(opt_scale), 100, 20);
	gtk_range_set_update_policy(GTK_RANGE(opt_scale), GTK_UPDATE_DELAYED);
	gtk_scale_set_digits(GTK_SCALE(opt_scale), 0);
	gtk_scale_set_draw_value(GTK_SCALE(opt_scale), FALSE);
	gtk_box_pack_start(GTK_BOX(opt_hbox), opt_scale, FALSE, TRUE, 0);

	title_label = gtk_label_new(WBR_STR_GRAPH_DISP2);
	gtk_misc_set_alignment(GTK_MISC(title_label), 0, 0);
	gtk_box_pack_start(GTK_BOX(opt_hbox), title_label, FALSE, TRUE, 0);

	// դ
	opt_hbox = gtk_hbox_new(FALSE, 10);
	gtk_box_pack_start(GTK_BOX(opt_vbox), opt_hbox, FALSE, TRUE, 5);

	title_label = gtk_label_new(WBR_STR_LINE_WIDTH1);
	gtk_misc_set_alignment(GTK_MISC(title_label), 0, 0);
	gtk_box_pack_start(GTK_BOX(opt_hbox), title_label, FALSE, TRUE, 0);

	opt_value = (gdouble)((gint)wbr_get_param(WBR_PRM_ID_LINEWIDTH));
	Wbro_line_width = (GtkAdjustment *)gtk_adjustment_new(opt_value,
										1.0, 5.0, 1.0, 1.0, 0.0);
	opt_scale = gtk_hscale_new(GTK_ADJUSTMENT(Wbro_line_width));
	gtk_widget_set_usize(GTK_WIDGET(opt_scale), 100, 20);
	gtk_range_set_update_policy(GTK_RANGE(opt_scale), GTK_UPDATE_DELAYED);
	gtk_scale_set_digits(GTK_SCALE(opt_scale), 0);
	gtk_scale_set_draw_value(GTK_SCALE(opt_scale), FALSE);
	gtk_box_pack_start(GTK_BOX(opt_hbox), opt_scale, FALSE, TRUE, 0);

	title_label = gtk_label_new(WBR_STR_LINE_WIDTH2);
	gtk_misc_set_alignment(GTK_MISC(title_label), 0, 0);
	gtk_box_pack_start(GTK_BOX(opt_hbox), title_label, FALSE, TRUE, 0);

	// ɽ
	opt_hbox = gtk_hbox_new(FALSE, 10);
	gtk_box_pack_start(GTK_BOX(opt_vbox), opt_hbox, FALSE, TRUE, 5);

	title_label = gtk_label_new(WBR_STR_DISP_DAY1);
	gtk_misc_set_alignment(GTK_MISC(title_label), 0, 0);
	gtk_box_pack_start(GTK_BOX(opt_hbox), title_label, FALSE, TRUE, 0);

	opt_value = (gdouble)((gint)wbr_get_param(WBR_PRM_ID_DISPPERIOD));
	Wbro_disp_day = (GtkAdjustment *)gtk_adjustment_new(opt_value,
										1.0, 999.0, 1.0, 5.0, 0.0);
	opt_spin = gtk_spin_button_new(Wbro_disp_day, 0, 0);
	gtk_spin_button_set_wrap(GTK_SPIN_BUTTON(opt_spin), TRUE);
	gtk_spin_button_set_shadow_type(GTK_SPIN_BUTTON(opt_spin),
									GTK_SHADOW_ETCHED_IN);
	gtk_widget_set_usize(GTK_WIDGET(opt_spin), 55, 0);
	gtk_box_pack_start(GTK_BOX(opt_hbox), opt_spin, FALSE, TRUE, 0);

	title_label = gtk_label_new(WBR_STR_DISP_DAY2);
	gtk_misc_set_alignment(GTK_MISC(title_label), 0, 0);
	gtk_box_pack_start(GTK_BOX(opt_hbox), title_label, FALSE, TRUE, 0);

	// ɽ
	Wbro_birth_year =
		gtk_check_button_new_with_label(WBR_STR_BIRTH_YEAR);
	gtk_box_pack_start(GTK_BOX(opt_vbox),
			Wbro_birth_year, FALSE, TRUE, 0);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(Wbro_birth_year),
					(gboolean)wbr_get_param(WBR_PRM_ID_BIRTHYEAR));

	// ɽ
	Wbro_total = gtk_check_button_new_with_label(WBR_STR_TOTAL);
	gtk_box_pack_start(GTK_BOX(opt_vbox), Wbro_total, FALSE, TRUE, 0);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(Wbro_total),
					(gboolean)wbr_get_param(WBR_PRM_ID_DISPTOTAL));

	// ɽ
	Wbro_day_line = gtk_check_button_new_with_label(WBR_STR_DAY_LINE);
	gtk_box_pack_start(GTK_BOX(opt_vbox),
			Wbro_day_line, FALSE, TRUE, 0);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(Wbro_day_line),
					(gboolean)wbr_get_param(WBR_PRM_ID_DAYLINE));

	// ѥ졼
	opt_sep = gtk_hseparator_new();
	gtk_box_pack_start(GTK_BOX(opt_vbox), opt_sep, FALSE, TRUE, 5);

	// ܥ
	cmd_hbox = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_end(GTK_BOX(opt_vbox), cmd_hbox, FALSE, TRUE, 0);

	cmd_cancel = gtk_button_new_with_label(WBR_STR_BTN_CANCEL);
	gtk_box_pack_end(GTK_BOX(cmd_hbox), cmd_cancel, FALSE, TRUE, 5);
	gtk_signal_connect(GTK_OBJECT(cmd_cancel), "clicked",
						GTK_SIGNAL_FUNC(wmc_dialog_close_clicked),
						GTK_OBJECT(opt_window));
	GTK_WIDGET_SET_FLAGS(cmd_cancel, GTK_CAN_DEFAULT);
	gtk_widget_grab_default(cmd_cancel);

	cmd_ok = gtk_button_new_with_label(WBR_STR_BTN_SET);
	gtk_box_pack_end(GTK_BOX(cmd_hbox), cmd_ok, FALSE, TRUE, 5);
	gtk_signal_connect(GTK_OBJECT(cmd_ok), "clicked",
						GTK_SIGNAL_FUNC(wbro_cb_ok_clicked),
						GTK_OBJECT(opt_window));
	GTK_WIDGET_SET_FLAGS(cmd_ok, GTK_CAN_DEFAULT);
	gtk_widget_grab_default(cmd_ok);

	gtk_window_set_modal(GTK_WINDOW(opt_window), TRUE);
	gtk_window_set_transient_for(GTK_WINDOW(opt_window),
								GTK_WINDOW(parent));

	return opt_window;
}
