/*
 * Хꥺɽե
 *	;μ
 *
 * Copyright (C) 1999,2000 Whitire Company (tonton@whitire.com)
 * $Id: br_user.c,v 1.1 2000/06/28 01:08:00 tonton Exp $
 */

#include "sys/param.h"
#include <gtk/gtk.h>
#include "stdio.h"
#include "stdlib.h"
#include "string.h"
#include "time.h"

#include "brthm.h"
#include "br_sdef.h"

#define		WBRU_DATFILE	"brthm.dat"
#define		WBRU_FILEVER	1

/*===============
 *   ̾ : wbr_set_datfile()
 *     ǽ : ;
 *    : TRUE= ｪλ
 */
gboolean			wbr_set_datfile(
WBR_MAN_INFO		*man_info,			// (I/O) ;
gchar				*name,				// ( I ) ̾
time_t				birthday,			// ( I ) 
gboolean			selected			// ( I ) 
)
{
	gboolean		ret_code = TRUE;	// 

	man_info->man_cnt++;
	man_info->man_dat = g_realloc(man_info->man_dat,
							sizeof(WBR_MAN_DAT) * man_info->man_cnt);
	if (*name == '\0') {
		strcpy(man_info->man_dat[man_info->man_cnt - 1].name,
												WBR_STR_NONAME);
	}
	else {
		strcpy(man_info->man_dat[man_info->man_cnt - 1].name, name);
	}
	man_info->man_dat[man_info->man_cnt - 1].birthday = birthday;
	man_info->man_dat[man_info->man_cnt - 1].selected = selected;

	return ret_code;
}

/*===============
 *   ̾ : wbr_set_selected()
 *     ǽ : ֤
 *    : ʤ
 */
void				wbr_set_selected(
WBR_MAN_INFO		*man_info,			// (I/O) ;
gint				man_no,				// ( I ) ֹ
gboolean			selected			// ( I ) 
)
{
	man_info->man_dat[man_no].selected = selected;
}

/*===============
 *   ̾ : wbr_delete_datfile()
 *     ǽ : ;κ
 *    : TRUE= ｪλ
 */
gboolean			wbr_delete_datfile(
WBR_MAN_INFO		*man_info,			// (I/O) ;
gint				man_no				// ( I ) ֹ
)
{
	gboolean		ret_code = TRUE;	// 

	man_info->man_cnt--;
	memmove(&man_info->man_dat[man_no],
			&man_info->man_dat[man_no + 1],
			(man_info->man_cnt - man_no) * sizeof(WBR_MAN_DAT));
	memset(&man_info->man_dat[man_info->man_cnt],
							0, sizeof(WBR_MAN_DAT));

	return ret_code;
}

/*===============
 *   ̾ : wbr_read_datfile()
 *     ǽ : ;եɤ߹
 *    : TRUE= ｪλ, FALSE= եʤʤ
 */
gboolean			wbr_read_datfile(
WBR_MAN_INFO		*man_info			// (O) ;
)
{
	gboolean		ret_code = TRUE;	// 
	gint			file_ver;			// եС
	gchar			fname[MAXPATHLEN];	// ե̾
	FILE			*infp;				// եݥ

	memset(man_info, 0, sizeof(WBR_MAN_INFO));
	
	strcpy(fname, WBRU_DATFILE);
	infp = fopen(fname, "r");
	if (infp) {
		fread(&file_ver, sizeof(gint), 1, infp);
		if (file_ver == 1) {
			fread(&man_info->man_cnt, sizeof(gint), 1, infp);
			man_info->man_dat =
				g_malloc0(man_info->man_cnt * sizeof(WBR_MAN_DAT));
			fread(man_info->man_dat, sizeof(WBR_MAN_DAT),
								man_info->man_cnt, infp);
		}

		fclose(infp);
	}
	else {
		perror(fname);
		ret_code = FALSE;
	}

	return ret_code;
}

/*===============
 *   ̾ : wbr_write_datfile()
 *     ǽ : ;եν񤭹
 *    : TRUE= ｪλ, FALSE= ѡߥåʤʤ
 */
gboolean			wbr_write_datfile(
WBR_MAN_INFO		*man_info			// (I) ;
)
{
	gboolean		ret_code = TRUE;	// 
	gint			file_ver;			// եС
	gchar			fname[MAXPATHLEN];	// ե̾
	FILE			*outfp;				// եݥ

	strcpy(fname, WBRU_DATFILE);
	outfp = fopen(fname, "w");
	if (outfp) {
		file_ver = WBRU_FILEVER;
		fwrite(&file_ver, sizeof(gint), 1, outfp);
		fwrite(&man_info->man_cnt, sizeof(gint), 1, outfp);
		fwrite(man_info->man_dat, sizeof(WBR_MAN_DAT),
								man_info->man_cnt, outfp);

		fclose(outfp);
	}
	else {
		perror(fname);
		ret_code = FALSE;
	}

	return ret_code;
}
