/*
 * Хꥺɽե
 *	ܤץȥ
 *
 * Copyright (C) 1999,2000 Whitire Company (tonton@whitire.com)
 * $Id: brthm.h,v 1.2 2000/06/28 01:08:00 tonton Exp $
 */

#ifndef __BRTHM_H__
#define		__BRTHM_H__

#include <gtk/gtk.h>
#include <time.h>

#define		WBR_INTERVAL	5
#define		WBR_CYCLE_PHYS	23
#define		WBR_CYCLE_SENS	28
#define		WBR_CYCLE_INTEL	33

enum {
	WBR_TYPE_PHYS = 1,
	WBR_TYPE_SENS = 2,
	WBR_TYPE_INTEL = 4,
	WBR_TYPE_WARN = 8
};

enum {
	WBR_PRM_ID_USERNAME = 1,
	WBR_PRM_ID_BIRTHDAY,
	WBR_PRM_ID_DISPPERIOD,
	WBR_PRM_ID_BIRTHYEAR,
	WBR_PRM_ID_DISPTOTAL,
	WBR_PRM_ID_CALENDAR,

	WBR_PRM_ID_GRAPHPOINT,
	WBR_PRM_ID_GRAPHWIDTH,
	WBR_PRM_ID_GRAPHHEIGHT,
	WBR_PRM_ID_LINEWIDTH,
	WBR_PRM_ID_GRAPHDISP,
	WBR_PRM_ID_DAYLINE,
	WBR_PRM_ID_GRAPHFORE,
	WBR_PRM_ID_GRAPHBACK,
	WBR_PRM_ID_GRAPHPHYS,
	WBR_PRM_ID_GRAPHSENS,
	WBR_PRM_ID_GRAPHINTEL,

	WBR_PRM_ID_DISPDAY,
	WBR_PRM_ID_BIRTHNUM
};

typedef struct {
	gchar			name[41];			// ̾
	time_t			birthday;			// 
	gboolean		selected;			// 
} WBR_MAN_DAT;

typedef struct {
	gint			man_cnt;			// 
	WBR_MAN_DAT		*man_dat;			// 
} WBR_MAN_INFO;

// br_window.c
extern void			wbr_set_birthday_info(void);
extern GtkWidget	*wbr_create_main_window(void);

// br_draw.c
extern void			wbr_init_psi_table(void);
extern void			wbr_draw_brthm(void);
extern void			wbr_modify_color_gc(gint);
extern GtkWidget	*wbr_create_draw_area(GtkWidget *);

// br_birth.c
extern void			wbr_cb_mview_spcbirth_clicked(GtkWidget *,
												gpointer, guint);

// br_user.c
gboolean			wbr_set_datfile(WBR_MAN_INFO *,
							gchar *, time_t, gboolean);
void				wbr_set_selected(WBR_MAN_INFO *, gint, gboolean);
gboolean			wbr_delete_datfile(WBR_MAN_INFO *, gint);
gboolean			wbr_read_datfile(WBR_MAN_INFO *);
gboolean			wbr_write_datfile(WBR_MAN_INFO *);

// br_idate.c
extern void			wbr_cb_mview_date_specify_clicked(GtkWidget *,
												gpointer, guint);

// br_color.c
extern void			wbr_cb_mview_color_clicked(GtkWidget *,
												gpointer, guint);

// br_option.c
extern void			wbr_cb_mview_option_clicked(GtkWidget *,
												gpointer, guint);

// br_about.c
extern void			wbr_cb_mhelp_about_clicked(GtkWidget *,
												gpointer, guint);

// br_param.c
extern void			*wbr_get_param(gint);
extern void			wbr_put_param(gint, void *);
extern void			wbr_init_user_info(void);
extern void			*wbr_get_user_info(gint, gint);
extern void			wbr_put_user_info(gchar *, time_t);
extern void			wbr_set_default_color(void);
extern gboolean		wbr_read_inifile(void);
extern gboolean		wbr_write_inifile(void);

#endif /* __BRTHM_H__ */
